Skip to main content
POST
/
project
/
{project_id}
/
location
/
{location}
/
postgres
/
{postgres_database_reference}
Create a new PostgreSQL database
curl --request POST \
  --url https://api.ubicloud.com/project/{project_id}/location/{location}/postgres/{postgres_database_reference} \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "size": "<string>",
  "storage_size": 123,
  "flavor": "<string>",
  "ha_type": "<string>",
  "restrict_by_default": true,
  "private_subnet_name": "<string>",
  "pg_config": {
    "max_connections": "100"
  },
  "pgbouncer_config": {
    "max_client_conn": "100"
  },
  "tags": [
    {
      "key": "<string>",
      "value": "<string>"
    }
  ]
}
'
import requests

url = "https://api.ubicloud.com/project/{project_id}/location/{location}/postgres/{postgres_database_reference}"

payload = {
    "size": "<string>",
    "storage_size": 123,
    "flavor": "<string>",
    "ha_type": "<string>",
    "restrict_by_default": True,
    "private_subnet_name": "<string>",
    "pg_config": { "max_connections": "100" },
    "pgbouncer_config": { "max_client_conn": "100" },
    "tags": [
        {
            "key": "<string>",
            "value": "<string>"
        }
    ]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    size: '<string>',
    storage_size: 123,
    flavor: '<string>',
    ha_type: '<string>',
    restrict_by_default: true,
    private_subnet_name: '<string>',
    pg_config: {max_connections: '100'},
    pgbouncer_config: {max_client_conn: '100'},
    tags: [{key: '<string>', value: '<string>'}]
  })
};

fetch('https://api.ubicloud.com/project/{project_id}/location/{location}/postgres/{postgres_database_reference}', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));


{
  "flavor": "<string>",
  "ha_type": "<string>",
  "target_server_count": 123,
  "id": "pgn30gjk1d1e2jj34v9x0dq4rp",
  "location": "<string>",
  "name": "<string>",
  "state": "<string>",
  "storage_size_gib": 123,
  "vm_size": "<string>",
  "maintenance_window_start_at": 123,
  "read_replica": true,
  "fallback_active": true,
  "tags": [
    {
      "key": "<string>",
      "value": "<string>"
    }
  ],
  "created_at": "2023-11-07T05:31:56Z",
  "connection_string": "<string>",
  "username": "<string>",
  "password": "<string>",
  "hostname": "<string>",
  "earliest_restore_time": "<string>",
  "firewall_rules": [
    {
      "cidr": "<string>",
      "id": "frmjgkgbktw62k53005jpx8tt7",
      "description": "<string>",
      "port": 123
    }
  ],
  "latest_restore_time": "<string>",
  "primary": true,
  "target_storage_size_gib": 123,
  "target_vm_size": "<string>",
  "ca_certificates": "<string>",
  "parent": "<string>"
}
{
  "error": {
    "code": 401,
    "message": "There was an error logging in",
    "type": "InvalidCredentials",
    "details": {}
  }
}

Authorizations

Authorization
string
header
required

Bearer authentication header of the form Bearer <token>, where <token> is your auth token.

Path Parameters

project_id
string
required

ID of the project

Pattern: ^pj[0-9a-hj-km-np-tv-z]{24}$
Example:

"pjkkmx0f2vke4h36nk9cm8v8q0"

location
string
required

The Ubicloud location/region

Example:

"eu-central-h1"

postgres_database_reference
string
required

Postgres database ID or name Resource ID or name

Pattern: ^[a-z0-9](?:[a-z0-9\-]{0,61}[a-z0-9])?$

Body

application/json
size
string
required

Requested size for the underlying VM

storage_size
integer
required

Requested storage size in GiB

flavor
string

Kind of database

ha_type
string

High availability type

version
enum<string>

PostgreSQL version

Available options:
16,
17,
18
restrict_by_default
boolean

Whether to restrict access by default (if so, firewall rules must be added to access)

private_subnet_name
string

Name for the private subnet (if not provided, a name will be auto-generated)

pg_config
object
Example:
{ "max_connections": "100" }
pgbouncer_config
object
Example:
{ "max_client_conn": "100" }
tags
object[]

Tags for the Postgres Database

Response

A Postgres Database

flavor
string
required

Kind of Postgres database

ha_type
string
required

High availability type

target_server_count
integer
required

Target number of servers (primary + standbys)

id
string
required

ID of the Postgres database

Pattern: ^pg[0-9a-hj-km-np-tv-z]{24}$
Example:

"pgn30gjk1d1e2jj34v9x0dq4rp"

location
string
required

Location of the Postgres database

name
string
required

Name of the Postgres database

state
string
required

State of the Postgres database

storage_size_gib
integer
required

Storage size in GiB

version
enum<string>
required

Current Postgres version

Available options:
16,
17,
18
target_version
enum<string>
required

Target Postgres version

Available options:
16,
17,
18
vm_size
string
required

Size of the underlying VM

maintenance_window_start_at
integer | null
required

Maintenance window start time

read_replica
boolean
required

If the database is a read replica or not

fallback_active
boolean
required

Whether the primary server is running on a fallback instance type

tags
object[]
required

Tags of the Postgres database

created_at
string<date-time>
required

Creation timestamp of the Postgres database

connection_string
string | null
required

Connection string to the Postgres database

username
string | null
required

Username for the Postgres database

password
string | null
required

Password for the Postgres database

hostname
string | null
required

Hostname for the Postgres database

earliest_restore_time
string | null
required

Earliest restore time (if primary)

firewall_rules
object[]
required

List of Postgres firewall rules

latest_restore_time
string
required

Latest restore time (if primary)"

primary
boolean
required

Is the database primary

target_storage_size_gib
integer

Desired storage size in GiB

target_vm_size
string

Desired VM size

ca_certificates
string | null

CA certificates of the root CA used to issue postgres server certificates

parent
string | null

Parent Postgres database